# Wrapper script to enable logging of test outputs on shell.
# Unfortunatly CMake add_test() does not have such a feature.

cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

# ----
# These variables are passed to the wrapped script
set(EXTRA -Wdev -Werror=dev)
set(MYCMAKE_SCRIPTS_DIR "@MYCMAKE_SCRIPTS_DIR@")
set(MYCMAKE_SCRIPTS_EXTRA_DIR "@MYCMAKE_SCRIPTS_DIR@")
set(MYCMAKE_CTEST_TEST_NAME "@MYCMAKE_CTEST_TEST_NAME@")
set(MYCMAKE_CTEST_TEST_SOURCE_DIR "@MYCMAKE_CTEST_TEST_SOURCE_DIR@")
set(MYCMAKE_CTEST_TEST_BINARY_DIR "@MYCMAKE_CTEST_TEST_BINARY_DIR@")
set(MYCMAKE_CTEST_TEST_INSTALL_DIR "@MYCMAKE_CTEST_TEST_INSTALL_DIR@")
set(MYCMAKE_CTEST_PACKAGE_SOURCE_DIR "@MYCMAKE_CTEST_PACKAGE_SOURCE_DIR@")
set(MYCMAKE_CTEST_PACKAGE_BINARY_DIR "@MYCMAKE_CTEST_PACKAGE_BINARY_DIR@")
set(MYCMAKE_CTEST_SOURCE_DIR "@MYCMAKE_CTEST_SOURCE_DIR@")
set(MYCMAKE_CTEST_BINARY_DIR "@MYCMAKE_CTEST_BINARY_DIR@")
set(MYCMAKE_CTEST_TEST_LOG_FILE "@MYCMAKE_CTEST_TEST_LOG_FILE@")
set(MYCMAKE_DEBUG_MESSAGES "@MYCMAKE_DEBUG_MESSAGES@")
set(MYCMAKE_CURRENT_POSTFIX "@MYCMAKE_CURRENT_POSTFIX@")
set(WORKING_DIRECTORY "@WORKING_DIRECTORY@")
set(CMAKE_GENERATOR "@CMAKE_GENERATOR@")
# ---- Passed since they are empty in scripts... why?
set(CMAKE_SYSTEM_NAME "@CMAKE_SYSTEM_NAME@")
set(CMAKE_HOST_SYSTEM_NAME "@CMAKE_HOST_SYSTEM_NAME@")
set(CMAKE_SYSTEM_VERSION "@CMAKE_SYSTEM_VERSION@")
set(CMAKE_HOST_SYSTEM_VERSION "@CMAKE_HOST_SYSTEM_VERSION@")
set(CMAKE_SIZEOF_VOID_P "@CMAKE_SIZEOF_VOID_P@")
set(CMAKE_SHARED_LIBRARY_PREFIX "@CMAKE_SHARED_LIBRARY_PREFIX@")
set(CMAKE_SHARED_LIBRARY_SUFFIX "@CMAKE_SHARED_LIBRARY_SUFFIX@")
set(CMAKE_STATIC_LIBRARY_PREFIX "@CMAKE_STATIC_LIBRARY_PREFIX@")
set(CMAKE_STATIC_LIBRARY_SUFFIX "@CMAKE_STATIC_LIBRARY_SUFFIX@")
set(CMAKE_EXECUTABLE_SUFFIX "@CMAKE_EXECUTABLE_SUFFIX@")
set(CMAKE_C_COMPILER_ID @CMAKE_C_COMPILER_ID@)
set(CMAKE_CXX_COMPILER_ID @CMAKE_CXX_COMPILER_ID@)
set(CMAKE_MAKE_PROGRAM "@CMAKE_MAKE_PROGRAM@")
# ----

set(COMMAND "@COMMAND@")
set(NO_PASS @NO_PASS@)

set(params_LOG_FILE)
    if (MYCMAKE_CTEST_TEST_LOG_FILE)
    set (params_LOG_FILE OUTPUT_FILE "${MYCMAKE_CTEST_TEST_LOG_FILE}" ERROR_FILE "${MYCMAKE_CTEST_TEST_LOG_FILE}")
endif (MYCMAKE_CTEST_TEST_LOG_FILE)

if (NO_PASS)
    execute_process(
        COMMAND
            ${COMMAND}
        WORKING_DIRECTORY
            ${WORKING_DIRECTORY}
            ${params_LOG_FILE}
        RESULT_VARIABLE
        RESULT_VAR
    )
else (NO_PASS)
    execute_process(
        COMMAND
            ${CMAKE_COMMAND}
        ${EXTRA}
        -DMYCMAKE_SCRIPTS_DIR=${MYCMAKE_SCRIPTS_DIR}
        -DMYCMAKE_SCRIPTS_EXTRA_DIR=${MYCMAKE_SCRIPTS_EXTRA_DIR}
        -DMYCMAKE_CTEST_TEST_NAME=${MYCMAKE_CTEST_TEST_NAME}
        -DMYCMAKE_CTEST_TEST_SOURCE_DIR=${MYCMAKE_CTEST_TEST_SOURCE_DIR}
        -DMYCMAKE_CTEST_TEST_BINARY_DIR=${MYCMAKE_CTEST_TEST_BINARY_DIR}
        -DMYCMAKE_CTEST_TEST_INSTALL_DIR=${MYCMAKE_CTEST_TEST_INSTALL_DIR}
        -DMYCMAKE_CTEST_PACKAGE_SOURCE_DIR=${MYCMAKE_CTEST_PACKAGE_SOURCE_DIR}
        -DMYCMAKE_CTEST_PACKAGE_BINARY_DIR=${MYCMAKE_CTEST_PACKAGE_BINARY_DIR}
        -DMYCMAKE_CTEST_SOURCE_DIR=${MYCMAKE_CTEST_SOURCE_DIR}
        -DMYCMAKE_CTEST_BINARY_DIR=${MYCMAKE_CTEST_BINARY_DIR}
        -DMYCMAKE_CTEST_TEST_LOG_FILE=${MYCMAKE_CTEST_TEST_LOG_FILE}
        -DMYCMAKE_DEBUG_MESSAGES=${MYCMAKE_DEBUG_MESSAGES}
        -DMYCMAKE_CURRENT_POSTFIX=${MYCMAKE_CURRENT_POSTFIX}
        -DWORKING_DIRECTORY=${WORKING_DIRECTORY}
        -DCMAKE_GENERATOR=${CMAKE_GENERATOR}
        # ----
        -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
        -DCMAKE_HOST_SYSTEM_NAME=${CMAKE_HOST_SYSTEM_NAME}
        -DCMAKE_SYSTEM_VERSION=${CMAKE_SYSTEM_VERSION}
        -DCMAKE_HOST_SYSTEM_VERSION=${CMAKE_HOST_SYSTEM_VERSION}
        -DCMAKE_SIZEOF_VOID_P=${CMAKE_SIZEOF_VOID_P}
        -DCMAKE_SHARED_LIBRARY_PREFIX=${CMAKE_SHARED_LIBRARY_PREFIX}
        -DCMAKE_SHARED_LIBRARY_SUFFIX=${CMAKE_SHARED_LIBRARY_SUFFIX}
        -DCMAKE_STATIC_LIBRARY_PREFIX=${CMAKE_STATIC_LIBRARY_PREFIX}
        -DCMAKE_STATIC_LIBRARY_SUFFIX=${CMAKE_STATIC_LIBRARY_SUFFIX}
        -DCMAKE_EXECUTABLE_SUFFIX=${CMAKE_EXECUTABLE_SUFFIX}
        -DCMAKE_C_COMPILER_ID=${CMAKE_C_COMPILER_ID}
        -DCMAKE_CXX_COMPILER_ID=${CMAKE_CXX_COMPILER_ID}
        -DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}
        ${COMMAND}
        WORKING_DIRECTORY
            ${WORKING_DIRECTORY}
        ${params_LOG_FILE}
        RESULT_VARIABLE
            RESULT_VAR
        )
endif (NO_PASS)

if (NO_PASS)
    set(MESSAGE "Test run without passing variables with exit code: ${RESULT_VAR}")
else (NO_PASS)
    set(MESSAGE "Test run passing variables with exit code: ${RESULT_VAR}")
endif (NO_PASS)

if (MYCMAKE_CTEST_TEST_LOG_FILE)
    file(APPEND ${MYCMAKE_CTEST_TEST_LOG_FILE} ${MESSAGE})
endif (MYCMAKE_CTEST_TEST_LOG_FILE)

if (RESULT_VAR)
    message(FATAL_ERROR ${MESSAGE})
endif (RESULT_VAR)

# EOF
